(* Title:  Knowledge/biegelinie-2.sml
   author: Walther Neuper 190515
   (c) due to copyright terms
*)
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"----------- auto SubProblem (_,[vonBelastungZu,Biegelinien] -----";
"----------- SubProblem me_Apply_Method_Biegelinien_ausBelastung -------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
open Kernel;

"----------- auto SubProblem (_,[vonBelastungZu,Biegelinien] -----";
"----------- auto SubProblem (_,[vonBelastungZu,Biegelinien] -----";
"----------- auto SubProblem (_,[vonBelastungZu,Biegelinien] -----";
val fmz = 
    ["Streckenlast q_0", "FunktionsVariable x",
     "Funktionen [Q x = c + - 1 * q_0 * x, \
     \M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2,\
     \ y' x = c_3 + 1 / (- 1 * EI) * (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3),\
     \ y x = c_4 + c_3 * x + 1 / (- 1 * EI) * (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4)]",
  (* additional for MethodC "Biegelinien/ausBelastung".. *)
     "Biegelinie y",
     "AbleitungBiegelinie dy",
     "Biegemoment M_b",
     "Querkraft Q"];
val (dI',pI',mI') = ("Biegelinie", ["vonBelastungZu", "Biegelinien"],
		     ["Biegelinien", "ausBelastung"]);

States.reset ();
CalcTree @{context} [(fmz, (dI',pI',mI'))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;

val ((pt, p),_) = States.get_calc 1;
(* ERROR: THIS TEST WAS BROKEN BEFORE CS "eliminate ThmC.numerals_to_Free", 
   UNDETECTED BY Test_Isac_Short.thy ===========================================================\\
if p = ([], Res) andalso (get_obj g_res pt (fst p) |> UnparseC.term @{context}) =
   "[Q x = c + - 1 * q_0 * x, M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2,\n dy x =\n c_3 + 1 / (- 1 * EI) * (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3),\n y x =\n c_4 + c_3 * x +\n 1 / (- 1 * EI) *\n (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4)]"
then () else error "auto SubProblem (_,[vonBelastungZu,Biegelinien] changed";
===============================================================================================//*)


"----------- SubProblem me_Apply_Method_Biegelinien_ausBelastung -------------------------------";
"----------- SubProblem me_Apply_Method_Biegelinien_ausBelastung -------------------------------";
"----------- SubProblem me_Apply_Method_Biegelinien_ausBelastung -------------------------------";
(*
  See src/../Biegelinie.thy: subsection \<open>Survey on Methods\<close>.
  Thus "ROOT" below documents test setup; in fact it is the fst SubProblem
*)
val fmz = 
    ["Streckenlast q_0", "FunktionsVariable x",
     "Funktionen [Q x = c + - 1 * q_0 * x, \
     \M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2,\
     \ y' x = c_3 + 1 / (- 1 * EI) * (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3),\
     \ y x = c_4 + c_3 * x + 1 / (- 1 * EI) * (c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4)]",
  (* additional for MethodC "Biegelinien/ausBelastung".. *)
     "Biegelinie y",
     "AbleitungBiegelinie dy",
     "Biegemoment M_b",
     "Querkraft Q"];
val (dI',pI',mI') = ("Biegelinie", ["vonBelastungZu", "Biegelinien"],
		     ["Biegelinien", "ausBelastung"]);
val p = e_pos'; val c = [];
val (p,_,f,nxt,_,pt) = Test_Code.init_calc @{context} [(fmz, (dI',pI',mI'))]; val Model_Problem = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Streckenlast q_0" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "FunktionsVariable x" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Funktionen [Q x = c + - 1 * q_0 * x]" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Funktionen [Q x = c + - 1 * q_0 * x, M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2]" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Funktionen [Q x = c + - 1 * q_0 * x, M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2, y' x =\nc_3 +\n1 / (- 1 * EI) * (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3)]" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Find "Funktionen [M_b x = c_2 + c * x + - 1 * q_0 / 2 * x \<up> 2, Q x = c + - 1 * q_0 * x, y' x =\nc_3 +\n1 / (- 1 * EI) * (c_2 * x + c / 2 * x \<up> 2 + - 1 * q_0 / 6 * x \<up> 3), y x =\nc_4 + c_3 * x +\n1 / (- 1 * EI) *\n(c_2 / 2 * x \<up> 2 + c / 6 * x \<up> 3 + - 1 * q_0 / 24 * x \<up> 4)]" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Theory "Biegelinie" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Problem ["vonBelastungZu", "Biegelinien"] = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Specify_Method ["Biegelinien", "ausBelastung"] = nxt
  (* additional for MethodC "Biegelinien/ausBelastung".. *)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Biegelinie y" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "AbleitungBiegelinie dy" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Biegemoment M_b" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Add_Given "Querkraft Q" = nxt
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Apply_Method ["Biegelinien", "ausBelastung"] = nxt
(* final test ... ----------------------------------------------------------------------------*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; val Rewrite ("sym_neg_equal_iff_equal", _) = nxt
